<?xml version="1.0" encoding="UTF-8"?><record_update table="sp_widget">
    <sp_widget action="INSERT_OR_UPDATE">
        <category>custom</category>
        <client_script><![CDATA[function($timeout, $scope, $element, $q) {

	var c = this;

	c.handleImages = handleImages;

	c.images = [];

	c.setAnswer = function (complete) {

		$scope.$emit('pi-bh.submitting');

		c.server.get({
			action: 'setAnswer',
			caseId: c.options.cs.sysId,
			complete: complete
		}).then(function (r) {

			uploadImages(r.data.responseId).then(function () {

				$scope.$emit('pi-bh.refresh');
			});

		});
	}



	function handleImages(files) {

		c.images = files;

		$scope.$apply(function () {
			showImages(files);
		});
	}

	function showImages(files) {

		var preview = $element.find('.bhsi-preview')[0];

		for (var i = 0; i < files.length; i++) {

			var file = files[i];

			if (!file.type.startsWith('image/')){ continue; }

			var img = document.createElement("img");
			img.file = file;

			var div = document.createElement("div");
			div.appendChild(img);

			preview.appendChild(div);

			var readerUi = new FileReader();
			readerUi.onload = (imgProcessor)(img, preview);
			readerUi.readAsDataURL(file);
		}

	}

	function imgProcessor (aImg, preview) {
		return function(e) {
			aImg.src = e.target.result;
		};
	}

	function uploadImages(sysId) {



		return $q(function (resolve, reject) {

			function upload(file) {

				var caseId = c.options.cs.sysId;
				
				var path = "/api/now/attachment/file?table_name=x_pisn_bh_response&table_sys_id=" + sysId + "&file_name=" + file.name;
				
				var xhr = new XMLHttpRequest();
				xhr.open("POST", path, true);
				xhr.overrideMimeType(file.type);
				xhr.addEventListener("load", reqListener);
				xhr.setRequestHeader('X-UserToken', c.data.token);
				xhr.setRequestHeader('Content-Type', file.type);
				xhr.send(file);
			}

			function reqListener () {
				uploaded++;

				if (uploaded === count) {
					resolve();
				}
			}

			if (c.images.length === 0) {
				resolve();
			} else {

				var count = c.images.length;
				var uploaded = 0;

				for (var i = 0; i < c.images.length; i++) {
					upload(c.images[i]);
				}

			}


		});
	}
}]]></client_script>
        <controller_as>c</controller_as>
        <css>.pi-bh-step-image {

  label {
    width: 100%;
    max-width: 500px;
    height: 200px;
    text-align: center;
    display: flex;
    align-items: center;
    justify-content: center;
    background-color: #f9f9f9;
    font-size: 18px;
    border: 2px dashed #ccc;
    cursor: pointer;
    padding: 30px;
    font-weight: 300;
    margin: 0px auto;
  }

  .bhsi-preview {
    margin: 20px 0;
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    max-width: 600px;

    div {
      flex: 1 1 25%;
      max-height: 100px;
      padding: 5px;
    }

    img {
      height: 100%;
      max-width: 100%;
      border-radius: 3px;
    }

  }

}</css>
        <data_table>sp_instance</data_table>
        <demo_data/>
        <description/>
        <docs/>
        <field_list/>
        <has_preview>false</has_preview>
        <id>pi-bh-step-image</id>
        <internal>false</internal>
        <link><![CDATA[function (scope) {

	var dropbox;

	dropbox = document.getElementById("fileElemLabel");
	dropbox.addEventListener("dragenter", dragenter, false);
	dropbox.addEventListener("dragover", dragover, false);
	dropbox.addEventListener("drop", drop, false);

	function dragenter(e) {
		e.stopPropagation();
		e.preventDefault();
	}

	function dragover(e) {
		e.stopPropagation();
		e.preventDefault();
	}

	function drop(e) {
		e.stopPropagation();
		e.preventDefault();

		var dt = e.dataTransfer;
		var files = dt.files;

		scope.c.handleImages(files);
	}

}]]></link>
        <name>BH Step (Image)</name>
        <option_schema/>
        <public>false</public>
        <roles/>
        <script><![CDATA[(function() {

	data.token = gs.getSession().getSessionToken();

	if (input) {
		
		var cs = new Case(input.caseId);
		data.responseId = cs.postImageResponse(input.complete);

	}

})();]]></script>
        <servicenow>false</servicenow>
        <sys_class_name>sp_widget</sys_class_name>
        <sys_created_by>dylan.lindgren</sys_created_by>
        <sys_created_on>2018-08-18 09:00:49</sys_created_on>
        <sys_id>751951bcdb4ca70012e035a27a961954</sys_id>
        <sys_mod_count>91</sys_mod_count>
        <sys_name>BH Step (Image)</sys_name>
        <sys_package display_value="BeHeard" source="x_pisn_bh">90ff838bdbfbd300687c26b38a96191b</sys_package>
        <sys_policy/>
        <sys_scope display_value="BeHeard">90ff838bdbfbd300687c26b38a96191b</sys_scope>
        <sys_update_name>sp_widget_751951bcdb4ca70012e035a27a961954</sys_update_name>
        <sys_updated_by>dylan.lindgren</sys_updated_by>
        <sys_updated_on>2018-12-02 22:51:42</sys_updated_on>
        <template><![CDATA[<div class="pi-bh-step-image">
<h1>{{c.options.cs.cqi.question.label}}</h1>
  <div class="bhsi-dropzone">
    <input type="file" accept="image/*" multiple
           style="display:none" name="fileElem" id="fileElem"
           onchange="angular.element(this).scope().c.handleImages(this.files)">
    <label for="fileElem" id="fileElemLabel">
      <span>${Touch, click, or drag here to add photos}</span>
    </label>
  </div>

  <div class="bhsi-preview">
    <span ng-show="c.files.length === 0">No photos have been uploaded yet</span>
  </div>
  <div class="bhst-actions">
    <button ng-click="c.setAnswer(false)">
      ${Continue later}
    </button>
    <button class="bhsta-primary"
            ng-click="c.setAnswer(true)">
      <span ng-if="c.options.cs.cqi.stepNumber !== c.options.cs.wiz.stepCount - 1">
      	<span ng-if="c.images.length > 0">${Next}</span>
        <span ng-if="c.images.length === 0">${Skip}</span>
      </span>
      <span ng-if="c.options.cs.cqi.stepNumber === c.options.cs.wiz.stepCount - 1">
      	<span ng-if="c.images.length > 0">${Submit}</span>
        <span ng-if="c.images.length === 0">${Skip}</span>
      </span>
    </button>
  </div>
</div>]]></template>
    </sp_widget>
</record_update>
